#include "Person.h"
#include "Couple.h"

Person::Person(string f, string l, Couple *p=0) :
  firstName(f), lastName(l), parents(p) {
  if (p!=0) {
    p->childs.push_back(this);
  }
}

Person& Person::print(ostream& o=cout) {
  o << "First name: " << firstName << ", Last name: "    << lastName  << endl;
  return *this;
}

Person& Person::rename(string firstName) {
  this->firstName = firstName;
  return *this;
}

// Exercise 3:

ostream& operator<<(ostream & o, const Person& p) {
  o << p.firstName << " " << p.lastName;
  return o;
}

// Exercise 4:
bool operator <(const Person &p1, const Person &p2) {
  if (p1.parents == 0) { return 0; }
  if (&(p1.parents->first)  == &p2) { return 1; }
  if (&(p1.parents->second) == &p2) { return 1; }
  return (p1.parents->first < p2) || (p1.parents->second < p2);
}

bool operator >(const Person &p1, const Person &p2) {
  return p2<p1;
}

Person& ancestors(Person &p, string prefix="") {
  cout << prefix << p << endl;
  if (p.parents!=0) {
    cout << prefix << "ancestors:" << endl;
    ancestors(p.parents->first, prefix+"  ");
    ancestors(p.parents->second, prefix+"  ");
  }
  return p;
}

list<Person*> Person::childs() {
  list<Person *> childs;
  for (list<Couple *>::iterator couplesi = couples.begin();
       couplesi!= couples.end();
       couplesi++) {
    for(list<Person *>::iterator childsi = (*couplesi)->childs.begin();
	childsi!=(*couplesi)->childs.end();
	childsi++) {
      childs.push_back(*childsi);
    }
  }
  return childs;
}
