#ifndef PERSON_H
#define PERSON_H

#include <iostream>
#include <string>
#include <list>

class Couple;	// Exercise 3,4:

class Person {
  string firstName;
  string lastName;

  // Exercise 4:
  // a pointer to the couple of the parents of this person, or 0
  // if the parents are unknown
  const Couple * parents;
  // a list of all couples this person belonged to
  list<Couple *> couples;

public:
  Person(string firstName, string lastName, Couple *parents=0);

  Person& print(ostream& o=cout);
  Person& rename(string firstName);

  // Exercise 3:
  friend Person operator>>(Couple & parents, const string& firstName);
  friend std::ostream& operator<<(std::ostream & s, const Person& p);

  // Exercise 4:
  friend bool operator <(const Person &p1, const Person &p2);
  friend Person& ancestors(Person &p, string prefix);

  friend class Couple;

  // Remark: a proliferation of friends declarations as above is
  // typically a sign of bad design. In a real life program, we would
  // have provided accessors, and most friends declarations above
  // could have been avoided.

  list<Person*> childs();
};

Person& ancestors(Person &p, string prefix="");
bool operator >(const Person &p1, const Person &p2);

#endif	// PERSON_H
